Index: LMDZ5/trunk/libf/phylmd/physiq.F
===================================================================
--- LMDZ5/trunk/libf/phylmd/physiq.F	(revision 1791)
+++ LMDZ5/trunk/libf/phylmd/physiq.F	(revision 1797)
@@ -173,5 +173,4 @@
       PARAMETER (ok_region=.FALSE.)
 c======================================================================
-      real weak_inversion(klon),dthmin(klon)
       real seuil_inversion
       save seuil_inversion
@@ -184,5 +183,4 @@
       REAL zz,znum,zden
       REAL wmax_th(klon)
-      REAL zmax_th(klon)
       REAL tau_overturning_th(klon)
 
@@ -220,5 +218,5 @@
       REAL u(klon,klev)
       REAL v(klon,klev)
-      REAL t(klon,klev),theta(klon,klev),thetal(klon,klev)
+      REAL t(klon,klev),thetal(klon,klev)
 c thetal: ligne suivante a decommenter si vous avez les fichiers     MPL 20130625
 c fth_fonctions.F90 et parkind1.F90
@@ -227,5 +225,4 @@
       REAL qx(klon,klev,nqtot)
       REAL flxmass_w(klon,klev)
-      REAL omega(klon,klev) ! vitesse verticale en Pa/s
       REAL d_u(klon,klev)
       REAL d_v(klon,klev)
@@ -242,5 +239,4 @@
       real clw(klon,klev),elij(klon,klev,klev)
       real epmlmMm(klon,klev,klev),eplaMm(klon,klev)
-      real wdtrainA(klon,klev),wdtrainM(klon,klev)
 ! RomP <<<
 !IM definition dynamique o_trac dans phys_output_open
@@ -281,6 +277,4 @@
 c
 c
-c prw: precipitable water
-      real prw(klon)
 
       REAL convliq(klon,klev)  ! eau liquide nuageuse convective
@@ -295,6 +289,4 @@
 c flwp, fiwp = Liquid Water Path & Ice Water Path (kg/m2)
 c flwc, fiwc = Liquid Water Content & Ice Water Content (kg/kg)
-      REAL flwp(klon), fiwp(klon)
-      REAL flwc(klon,klev), fiwc(klon,klev)
       REAL flwp_c(klon), fiwp_c(klon)
       REAL flwc_c(klon,klev), fiwc_c(klon,klev)
@@ -302,5 +294,4 @@
       REAL flwc_s(klon,klev), fiwc_s(klon,klev)
 
-      REAL evap_pot(klon,nbsrf)
 
 cIM ISCCP simulator v3.4
@@ -528,10 +519,4 @@
 c$OMP THREADPRIVATE(itap)
 c
-      real slp(klon) ! sea level pressure
-c
-      REAL fevap(klon,nbsrf)
-      REAL fluxlat(klon,nbsrf)
-c
-      REAL qsol(klon)
       REAL,save ::  solarlong0
 c$OMP THREADPRIVATE(solarlong0)
@@ -544,6 +529,4 @@
 c
       INTEGER igwd,idx(klon),itest(klon)
-c
-      REAL agesno(klon,nbsrf)
 c
 c      REAL,allocatable,save :: run_off_lic_0(:)
@@ -565,5 +548,4 @@
 
       REAL mip(klon,klev)  ! mass flux shed by the adiab ascent at each level
-      REAL Vprecip(klon,klev+1)   ! precipitation vertical profile
 c
       REAL wape_prescr, fip_prescr
@@ -589,6 +571,4 @@
 c$OMP THREADPRIVATE(wake_s_min_lsp)
 
-      real ale_wake(klon)
-      real alp_wake(klon)
 
       real ok_wk_lsp(klon)
@@ -609,5 +589,4 @@
       REAL wake_dtPBL(klon,klev)      ! Wake : differential heating (wake - unpertubed) PBL
       REAL wake_dqPBL(klon,klev)      ! Wake : differential moistening (wake - unpertubed) PBL
-      REAL wake_omg(klon,klev)        ! Wake : velocity difference (wake - unpertubed)
       REAL wake_ddeltat(klon,klev),wake_ddeltaq(klon,klev)
       REAL wake_dp_deltomg(klon,klev) ! Wake : gradient vertical de wake_omg
@@ -615,5 +594,4 @@
 c
 cpourquoi y'a pas de save??
-      REAL wake_h(klon)               ! Wake : hauteur de la poche froide
 c
       INTEGER wake_k(klon)            ! Wake sommet
@@ -645,7 +623,5 @@
 cRR:fin declarations poches froides
 c=======================================================================================================
-
-      REAL zw2(klon,klev+1)
-      REAL fraca(klon,klev+1)        
+        
       REAL ztv(klon,klev),ztva(klon,klev)
       REAL zpspsk(klon,klev)
@@ -665,12 +641,6 @@
       real env_tke_max0(klon)                                ! TKE dans l'environnement au LCL 
 
-c---Spectre de thermiques de type 2 au LCL
-      real n2(klon),s2(klon)
-      real ale_bl_stat(klon)
-
 c---D\'eclenchement stochastique
       integer :: tau_trig(klon)
-      real proba_notrig(klon)
-      real random_notrig(klon)
 
 c--------Statistical Boundary Layer Closure: ALP_BL--------
@@ -680,10 +650,4 @@
       real env_tke_max(klon,klev)                            ! Profil de TKE dans l'environnement
 
-c---Fermeture statistique
-      real alp_bl_det(klon)                                     ! ALP d\'terministe du thermique unique
-      real alp_bl_fluct_m(klon)                                 ! ALP li\'ee aux fluctuations de flux de masse sous-nuageux
-      real alp_bl_fluct_tke(klon)                               ! ALP li\'ee aux fluctuations d'\'energie cin\'etique sous-nuageuse 
-      real alp_bl_conv(klon)                                    ! ALP li\'ee \`a grande \'echelle
-      real alp_bl_stat(klon)                                    ! ALP totale
 
 ccc fin nrlmd le 10/04/2012
@@ -697,12 +661,8 @@
 c Variables locales:
 c
-      REAL cdragh(klon) ! drag coefficient pour T and Q
-      REAL cdragm(klon) ! drag coefficient pour vent
 cAA
 cAA  Pour phytrac 
       REAL u1(klon)             ! vents dans la premiere couche U
       REAL v1(klon)             ! vents dans la premiere couche V
-
-      REAL zxffonte(klon), zxfqcalving(klon),zxfqfonte(klon)
 
 c@$$      LOGICAL offline           ! Controle du stockage ds "physique"
@@ -713,5 +673,4 @@
 ! RomP >>> 
       REAL beta_prec_fisrt(klon,klev) ! taux de conv de l'eau cond (fisrt)
-      REAL beta_prec(klon,klev)       ! taux de conv de l'eau cond (utilise)
 ! RomP <<<
       INTEGER       :: iii
@@ -722,23 +681,7 @@
 c
 cIM 050204 END
-      REAL evap(klon), devap(klon) ! evaporation et sa derivee
-      REAL sens(klon), dsens(klon) ! chaleur sensible et sa derivee
-
-      REAL bils(klon) ! bilan de chaleur au sol
-
-      REAL wfbilo(klon,nbsrf) ! bilan d'eau, pour chaque
-C                             ! type de sous-surface et pondere par la fraction
-      REAL wfbils(klon,nbsrf) ! bilan de chaleur au sol, pour chaque
-C                             ! type de sous-surface et pondere par la fraction
-      REAL slab_wfbils(klon)  ! bilan de chaleur au sol pour le cas de slab, sur les points d'ocean
-
-      REAL fder(klon)         
-      REAL ve(klon) ! integr. verticale du transport meri. de l'energie
-      REAL vq(klon) ! integr. verticale du transport meri. de l'eau
-      REAL ue(klon) ! integr. verticale du transport zonal de l'energie
-      REAL uq(klon) ! integr. verticale du transport zonal de l'eau
-c
-      REAL frugs(klon,nbsrf)
-      REAL zxrugs(klon) ! longueur de rugosite
+      REAL devap(klon) ! evaporation et sa derivee
+      REAL dsens(klon) ! chaleur sensible et sa derivee
+
 c
 c Conditions aux limites
@@ -804,13 +747,7 @@
       REAL diafra(klon,klev)  ! fraction nuageuse
       REAL cldliq(klon,klev)  ! eau liquide nuageuse
-      REAL cldfra(klon,klev)  ! fraction nuageuse
-      REAL cldtau(klon,klev)  ! epaisseur optique
-      REAL cldemi(klon,klev)  ! emissivite infrarouge
 c
 CXXX PB 
       REAL fluxq(klon,klev, nbsrf)   ! flux turbulent d'humidite
-      REAL fluxt(klon,klev, nbsrf)   ! flux turbulent de chaleur
-      REAL fluxu(klon,klev, nbsrf)   ! flux turbulent de vitesse u
-      REAL fluxv(klon,klev, nbsrf)   ! flux turbulent de vitesse v
 c
       REAL zxfluxt(klon, klev)
@@ -818,8 +755,5 @@
       REAL zxfluxu(klon, klev)
       REAL zxfluxv(klon, klev)
-CXXX
-c
-      REAL fsollw(klon, nbsrf)   ! bilan flux IR pour chaque sous surface
-      REAL fsolsw(klon, nbsrf)   ! flux solaire absorb. pour chaque sous surface
+
 c Le rayonnement n'est pas calcule tous les pas, il faut donc
 c                      sauvegarder les sorties du rayonnement
@@ -834,9 +768,7 @@
       REAL conv_q(klon,klev) ! convergence de l'humidite (kg/kg/s)
       REAL conv_t(klon,klev) ! convergence de la temperature(K/s)
-c
-      REAL cldl(klon),cldm(klon),cldh(klon) !nuages bas, moyen et haut
-      REAL cldt(klon),cldq(klon) !nuage total, eau liquide integree
-c
-      REAL zxtsol(klon), zxqsurf(klon), zxsnow(klon), zxfluxlat(klon)
+
+c
+      REAL zxsnow(klon)
       REAL zxsnow_dummy(klon)
 c
@@ -857,6 +789,5 @@
       REAL t_coup
       PARAMETER (t_coup=234.0)
-c
-      REAL zphi(klon,klev)
+
 cym A voir plus tard !!
 cym      REAL zx_relief(iim,jjmp1)
@@ -864,18 +795,12 @@
 c
 c Grandeurs de sorties
-      REAL s_pblh(klon), s_lcl(klon), s_capCL(klon)
-      REAL s_oliqCL(klon), s_cteiCL(klon), s_pblt(klon)
-      REAL s_therm(klon), s_trmb1(klon), s_trmb2(klon)
+      REAL s_capCL(klon)
+      REAL s_oliqCL(klon), s_cteiCL(klon)
+      REAL s_trmb1(klon), s_trmb2(klon)
       REAL s_trmb3(klon)
 cKE43
 c Variables locales pour la convection de K. Emanuel (sb):
-c
-      REAL upwd(klon,klev)      ! saturated updraft mass flux
-      REAL dnwd(klon,klev)      ! saturated downdraft mass flux
-      REAL dnwd0(klon,klev)     ! unsaturated downdraft mass flux
+
       REAL tvp(klon,klev)       ! virtual temp of lifted parcel
-      REAL plcl(klon)           ! Lifting Condensation Level
-      REAL plfc(klon)           ! Level of Free Convection
-      REAL wbeff(klon)          ! saturated updraft velocity at LFC
       CHARACTER*40 capemaxcels  !max(CAPE)
 
@@ -902,5 +827,4 @@
 c eva: evaporation de l'eau liquide nuageuse
 c vdf: couche limite (Vertical DiFfusion)
-      REAL rneb(klon,klev)
 
 ! tendance nulles
@@ -914,13 +838,7 @@
 cIM 081204 END
 c
-      REAL pmfu(klon,klev), pmfd(klon,klev)
       REAL pen_u(klon,klev), pen_d(klon,klev)
       REAL pde_u(klon,klev), pde_d(klon,klev)
       INTEGER kcbot(klon), kctop(klon), kdtop(klon)
-      REAL pmflxr(klon,klev+1), pmflxs(klon,klev+1)
-      REAL prfl(klon,klev+1), psfl(klon,klev+1)
-c
-      REAL rain_lsc(klon)
-      REAL snow_lsc(klon)
 c
       REAL ratqsc(klon,klev)
@@ -935,5 +853,4 @@
       logical ok_newmicro
       save ok_newmicro
-      real ref_liq(klon,klev), ref_ice(klon,klev)
 c$OMP THREADPRIVATE(ok_newmicro)
       save fact_cldcon,facttemps
@@ -973,8 +890,5 @@
 c Variables locales pour effectuer les appels en serie
 c
-      REAL zx_rh(klon,klev)
 cIM RH a 2m (la surface)
-      REAL rh2m(klon), qsat2m(klon)
-      REAL tpot(klon), tpote(klon)
       REAL Lheat
 
@@ -1091,16 +1005,11 @@
       REAL ZRCPD
 c-jld ec_conser
-      REAL t2m(klon,nbsrf)  ! temperature a 2m
       REAL q2m(klon,nbsrf)  ! humidite a 2m
 
 cIM: t2m, q2m, ustar, u10m, v10m et t2mincels, t2maxcels
-      REAL zt2m(klon), zq2m(klon)             !temp., hum. 2m moyenne s/ 1 maille
-      REAL zustar(klon),zu10m(klon), zv10m(klon)  ! u* et vents a 10m moyennes s/1 maille
       CHARACTER*40 t2mincels, t2maxcels       !t2m min., t2m max
       CHARACTER*40 tinst, tave, typeval
       REAL cldtaupi(klon,klev)  ! Cloud optical thickness for pre-industrial (pi) aerosols
 
-      REAL re(klon, klev)       ! Cloud droplet effective radius
-      REAL fl(klon, klev)  ! denominator of re
 
       REAL re_top(klon), fl_top(klon) ! CDR at top of liquid water clouds
@@ -1228,6 +1137,5 @@
 ! Utilise notamment en 1D mais peut etre active egalement en 3D
 ! en imposant la valeur de igout.
-c======================================================================
-
+c======================================================================d
       if (prt_level.ge.1) then
           igout=klon/2+1/klon
@@ -1250,15 +1158,4 @@
 
 c======================================================================
-
-cym => necessaire pour iflag_con != 2    
-      pmfd(:,:) = 0.
-      pen_u(:,:) = 0.
-      pen_d(:,:) = 0.
-      pde_d(:,:) = 0.
-      pde_u(:,:) = 0.
-      aam=0.
-
-      torsfc=0.
-      forall (k=1: llm) zmasse(:, k) = (paprs(:, k)-paprs(:, k+1)) / rg
 
       if (first) then 
@@ -1301,4 +1198,17 @@
 
       endif  ! first
+
+cym => necessaire pour iflag_con != 2    
+      pmfd(:,:) = 0.
+      pen_u(:,:) = 0.
+      pen_d(:,:) = 0.
+      pde_d(:,:) = 0.
+      pde_u(:,:) = 0.
+      aam=0.
+
+      torsfc=0.
+      forall (k=1: llm) zmasse(:, k) = (paprs(:, k)-paprs(:, k+1)) / rg
+
+
 
        modname = 'physiq'