Index: LMDZ5/trunk/libf/cosp/ini_histdayCOSP.h
===================================================================
--- LMDZ5/trunk/libf/cosp/ini_histdayCOSP.h	(revision 1866)
+++ LMDZ5/trunk/libf/cosp/ini_histdayCOSP.h	(revision 1871)
@@ -24,5 +24,5 @@
        endif
 
-        CALL histvert(nid_day_cosp,"height_mlev","height_mlev","m",Nlevlmdz,vgrid%mz,nvertm)
+        CALL histvert(nid_day_cosp,"height_mlev","height_mlev","m",Nlevlmdz,vgrid%mz,nvertmcosp)
 
         CALL histvert(nid_day_cosp,"sza","solar_zenith_angle","degrees",PARASOL_NREFL,PARASOL_SZA,nvertp)
@@ -82,5 +82,5 @@
              CALL histdef(nid_day_cosp, "atb532_"//chcol(ii), &
                          "Lidar Attenuated Total Backscatter (532 nm)","1", &
-                         iim,jj_nb,nhori, Nlevlmdz,1,Nlevlmdz,nvertm, 32, &
+                         iim,jj_nb,nhori, Nlevlmdz,1,Nlevlmdz,nvertmcosp, 32, &
                          "ave(X)", zout,zstoday)
             enddo
@@ -89,5 +89,5 @@
             CALL histdef(nid_day_cosp, "beta_mol532", &
                         "Lidar Molecular Backscatter (532 nm)","m-1 sr-1", &
-                        iim,jj_nb,nhori, Nlevlmdz,1,Nlevlmdz,nvertm, 32, &
+                        iim,jj_nb,nhori, Nlevlmdz,1,Nlevlmdz,nvertmcosp, 32, &
                          "ave(X)", zout,zstoday)
            endif
Index: LMDZ5/trunk/libf/cosp/ini_histhfCOSP.h
===================================================================
--- LMDZ5/trunk/libf/cosp/ini_histhfCOSP.h	(revision 1866)
+++ LMDZ5/trunk/libf/cosp/ini_histhfCOSP.h	(revision 1871)
@@ -24,5 +24,5 @@
        endif
 
-        CALL histvert(nid_hf_cosp,"height_mlev","height_mlev","m",Nlevlmdz,vgrid%mz,nvertm)
+        CALL histvert(nid_hf_cosp,"height_mlev","height_mlev","m",Nlevlmdz,vgrid%mz,nvertmcosp)
 
         CALL histvert(nid_hf_cosp,"sza","solar_zenith_angle","degrees",PARASOL_NREFL,PARASOL_SZA,nvertp)
@@ -82,5 +82,5 @@
              CALL histdef(nid_hf_cosp, "atb532_"//chcol(ii), &
                          "Lidar Attenuated Total Backscatter (532 nm)","1", &
-                         iim,jj_nb,nhori, Nlevlmdz,1,Nlevlmdz,nvertm, 32, &
+                         iim,jj_nb,nhori, Nlevlmdz,1,Nlevlmdz,nvertmcosp, 32, &
                          "ave(X)", zout,zstohf)
             enddo
@@ -89,5 +89,5 @@
             CALL histdef(nid_hf_cosp, "beta_mol532", &
                         "Lidar Molecular Backscatter (532 nm)","m-1 sr-1", &
-                        iim,jj_nb,nhori, Nlevlmdz,1,Nlevlmdz,nvertm, 32, &
+                        iim,jj_nb,nhori, Nlevlmdz,1,Nlevlmdz,nvertmcosp, 32, &
                          "ave(X)", zout,zstohf)
            endif
Index: LMDZ5/trunk/libf/cosp/ini_histmthCOSP.h
===================================================================
--- LMDZ5/trunk/libf/cosp/ini_histmthCOSP.h	(revision 1866)
+++ LMDZ5/trunk/libf/cosp/ini_histmthCOSP.h	(revision 1871)
@@ -23,5 +23,5 @@
         CALL histvert(nid_mth_cosp,"presnivs","Vertical levels","Pa",Nlevout,presnivs,nvert,"down")
        endif
-        CALL histvert(nid_mth_cosp,"height_mlev","height_mlev","m",Nlevlmdz,vgrid%mz,nvertm)
+        CALL histvert(nid_mth_cosp,"height_mlev","height_mlev","m",Nlevlmdz,vgrid%mz,nvertmcosp)
 
         CALL histvert(nid_mth_cosp,"sza","solar_zenith_angle","degrees",PARASOL_NREFL,PARASOL_SZA,nvertp)
@@ -64,9 +64,9 @@
 !         CALL histdef(nid_mth_cosp, "zlev_m", &
 !                     "Height at Midel model levels", "m", &
-!                     iim,jj_nb,nhori, Nlevlmdz,1,Nlevlmdz,nvertm, 32, &
+!                     iim,jj_nb,nhori, Nlevlmdz,1,Nlevlmdz,nvertmcosp, 32, &
 !                     "ave(X)", zout,zstomth)
 !         CALL histdef(nid_mth_cosp, "zlev_b", &
 !                     "Height at bottom model levels", "m", &
-!                     iim,jj_nb,nhori, Nlevlmdz,1,Nlevlmdz,nvertm, 32, &
+!                     iim,jj_nb,nhori, Nlevlmdz,1,Nlevlmdz,nvertmcosp, 32, &
 !                     "ave(X)", zout,zstomth)
          endif
@@ -89,5 +89,5 @@
              CALL histdef(nid_mth_cosp, "atb532_"//chcol(ii), &
                          "Lidar Attenuated Total Backscatter (532 nm)","1", &
-                         iim,jj_nb,nhori, Nlevlmdz,1,Nlevlmdz,nvertm, 32, &
+                         iim,jj_nb,nhori, Nlevlmdz,1,Nlevlmdz,nvertmcosp, 32, &
                          "ave(X)", zout,zstomth)
             enddo
@@ -96,5 +96,5 @@
             CALL histdef(nid_mth_cosp, "beta_mol532", &
                         "Lidar Molecular Backscatter (532 nm)","m-1 sr-1", &
-                        iim,jj_nb,nhori, Nlevlmdz,1,Nlevlmdz,nvertm, 32, &
+                        iim,jj_nb,nhori, Nlevlmdz,1,Nlevlmdz,nvertmcosp, 32, &
                          "ave(X)", zout,zstomth)
            endif
Index: LMDZ5/trunk/libf/cosp/phys_cosp.F90
===================================================================
--- LMDZ5/trunk/libf/cosp/phys_cosp.F90	(revision 1866)
+++ LMDZ5/trunk/libf/cosp/phys_cosp.F90	(revision 1871)
@@ -122,5 +122,5 @@
   real    :: zjulian,zstoday,zstomth,zstohf,zout,ecrit_day,ecrit_hf,ecrit_mth
   logical :: ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP
-  integer :: nhori,nvert,nvertp,nvertisccp,nvertm,nvertcol
+  integer :: nhori,nvert,nvertp,nvertisccp,nvertmcosp,nvertcol
   integer, save :: nid_day_cosp,nid_mth_cosp,nid_hf_cosp
 !$OMP THREADPRIVATE(nid_day_cosp,nid_mth_cosp,nid_hf_cosp)